import { User } from "oidc-client-ts";
/**
 * @public
 */
export declare const useAuth: () => {
    readonly user: import("vue").ComputedRef<{
        id_token?: string | undefined;
        session_state: string | null;
        access_token: string;
        refresh_token?: string | undefined;
        token_type: string;
        scope?: string | undefined;
        profile: {
            [x: string]: unknown;
            [x: number]: unknown;
            auth_time?: number | undefined;
            nonce?: string | undefined;
            acr?: string | undefined;
            amr?: unknown;
            azp?: string | undefined;
            sid?: string | undefined;
            sub: string;
            name?: string | undefined;
            profile?: string | undefined;
            given_name?: string | undefined;
            family_name?: string | undefined;
            middle_name?: string | undefined;
            nickname?: string | undefined;
            preferred_username?: string | undefined;
            picture?: string | undefined;
            website?: string | undefined;
            email?: string | undefined;
            email_verified?: boolean | undefined;
            gender?: string | undefined;
            birthdate?: string | undefined;
            zoneinfo?: string | undefined;
            locale?: string | undefined;
            phone_number?: string | undefined;
            phone_number_verified?: boolean | undefined;
            address?: {
                formatted?: string | undefined;
                street_address?: string | undefined;
                locality?: string | undefined;
                region?: string | undefined;
                postal_code?: string | undefined;
                country?: string | undefined;
            } | undefined;
            updated_at?: number | undefined;
            iss: string;
            aud: string | string[];
            exp: number;
            iat: number;
        };
        expires_at?: number | undefined;
        readonly state: unknown;
        expires_in: number | undefined;
        readonly expired: boolean | undefined;
        readonly scopes: string[];
        toStorageString: () => string;
    } | null | undefined>;
    readonly isLoading: import("vue").ComputedRef<boolean>;
    readonly isAuthenticated: import("vue").ComputedRef<boolean>;
    readonly activeNavigator: import("vue").ComputedRef<"signinRedirect" | "signinPopup" | "signinSilent" | "signoutRedirect" | "signoutPopup" | undefined>;
    readonly error: import("vue").ComputedRef<{
        name: string;
        message: string;
        stack?: string | undefined;
        cause?: any | undefined;
    } | undefined>;
    readonly settings: import("oidc-client-ts").UserManagerSettings;
    readonly events: import("oidc-client-ts").UserManagerEvents;
    readonly clearStaleState: () => Promise<void>;
    readonly removeUser: () => Promise<void>;
    readonly signinPopup: (args?: import("oidc-client-ts").SigninPopupArgs | undefined) => Promise<User>;
    readonly signinSilent: (args?: import("oidc-client-ts").SigninSilentArgs | undefined) => Promise<User | null>;
    readonly signinRedirect: (args?: import("oidc-client-ts").SigninRedirectArgs | undefined) => Promise<void>;
    readonly signoutRedirect: (args?: import("oidc-client-ts").SignoutRedirectArgs | undefined) => Promise<void>;
    readonly signoutPopup: (args?: import("oidc-client-ts").SignoutPopupArgs | undefined) => Promise<void>;
    readonly querySessionStatus: (args?: import("oidc-client-ts").QuerySessionStatusArgs | undefined) => Promise<import("oidc-client-ts").SessionStatus | null>;
    readonly revokeTokens: (types?: ("access_token" | "refresh_token")[] | undefined) => Promise<void>;
    readonly startSilentRenew: () => void;
    readonly stopSilentRenew: () => void;
};
/**
 * As not a child of AuthProvider. using "user" in the localStorage/sessionStorage
 * @public
 * @return return a useUser
 */
export declare const userGetterGen: (authority: string, clientId: string, storage?: Storage) => () => User | null;
