import { provide as S, ref as A, computed as l, unref as E, watchEffect as h, defineComponent as O, createVNode as N, Fragment as P, inject as m } from "vue";
import { UserManager as _, User as x } from "oidc-client-ts";
const R = Symbol(), C = (t) => {
  S(R, t);
}, D = {
  isLoading: !0,
  isAuthenticated: !1,
  user: null,
  activeNavigator: void 0,
  error: void 0
}, b = (t, e) => {
  switch (e.type) {
    case "INITIALISED":
    case "USER_LOADED":
      return {
        ...t,
        user: e.user,
        isLoading: !1,
        isAuthenticated: e.user ? !e.user.expired : !1,
        error: void 0
      };
    case "USER_UNLOADED":
      return {
        ...t,
        user: void 0,
        isAuthenticated: !1
      };
    case "NAVIGATOR_INIT":
      return {
        ...t,
        isLoading: !0,
        activeNavigator: e.method
      };
    case "NAVIGATOR_CLOSE":
      return {
        ...t,
        isLoading: !1,
        activeNavigator: void 0
      };
    case "ERROR":
      return {
        ...t,
        isLoading: !1,
        error: e.error
      };
    default:
      return {
        ...t,
        isLoading: !1,
        error: new Error(`unknown type ${e.type}`)
      };
  }
}, i = A(D), M = {
  user: l(() => i.value.user),
  isLoading: l(() => i.value.isLoading),
  isAuthenticated: l(() => i.value.isAuthenticated),
  activeNavigator: l(() => i.value.activeNavigator),
  error: l(() => i.value.error)
}, T = () => [M, (e) => {
  i.value = b(E(i), e);
}], U = Symbol(), G = (t) => {
  S(U, t);
}, V = (t = window.location) => {
  let e = new URLSearchParams(t.search);
  return !!((e.get("code") || e.get("error")) && e.get("state") || (e = new URLSearchParams(t.hash.replace("#", "?")), (e.get("code") || e.get("error")) && e.get("state")));
}, j = (t) => (e) => e instanceof Error ? e : new Error(t), $ = j("Login failed"), k = [
  "clearStaleState",
  "querySessionStatus",
  "revokeTokens",
  "startSilentRenew",
  "stopSilentRenew"
], K = [
  "signinPopup",
  "signinSilent",
  "signinRedirect",
  "signoutPopup",
  "signoutRedirect"
], v = (t) => () => {
  throw new Error(
    `UserManager#${t} was called from an unsupported context. If this is a server-rendered page, defer this call with useEffect() or pass a custom UserManager implementation.`
  );
}, q = typeof window > "u" ? null : _, z = (t) => {
  const {
    skipSigninCallback: e,
    onSigninCallback: u,
    onRemoveUser: c,
    implementation: o = q,
    ...p
  } = t, r = o ? new o(p) : { settings: p }, [w, a] = T(), L = {
    settings: r.settings,
    events: r.events,
    ...Object.fromEntries(
      k.map((n) => {
        var s, d;
        return [
          n,
          (d = (s = r[n]) == null ? void 0 : s.bind(r)) != null ? d : v(n)
        ];
      })
    ),
    ...Object.fromEntries(
      K.map((n) => [
        n,
        r[n] ? async (...s) => {
          a({
            type: "NAVIGATOR_INIT",
            method: n
          });
          try {
            return await r[n](...s);
          } finally {
            a({ type: "NAVIGATOR_CLOSE" });
          }
        } : v(n)
      ])
    )
  }, f = A(!1);
  h(async () => {
    if (!(!r || E(f))) {
      f.value = !0;
      try {
        if (V() && !e) {
          const s = await r.signinCallback();
          u && u(s);
        }
        const n = await r.getUser();
        a({ type: "INITIALISED", user: n });
      } catch (n) {
        a({ type: "ERROR", error: $(n) });
      }
    }
  }), h(() => {
    if (!r)
      return;
    const n = (g) => {
      a({ type: "USER_LOADED", user: g });
    };
    r.events.addUserLoaded(n);
    const s = () => {
      a({ type: "USER_UNLOADED" });
    };
    r.events.addUserUnloaded(s);
    const d = (g) => {
      a({ type: "ERROR", error: g });
    };
    return r.events.addSilentRenewError(d), () => {
      r.events.removeUserLoaded(n), r.events.removeUserUnloaded(s), r.events.removeSilentRenewError(d);
    };
  });
  const y = r ? () => r.removeUser().then(c) : v("removeUser"), I = {
    ...L,
    removeUser: y
  };
  return {
    state: w,
    context: I
  };
}, H = O({
  name: "AuthProvider",
  props: {
    options: {
      type: Object,
      required: !0
    }
  },
  setup(t, {
    slots: e
  }) {
    const {
      state: u,
      context: c
    } = z(t.options);
    return G(u), C(c), () => {
      var o;
      return N(P, null, [(o = e.default) == null ? void 0 : o.call(e)]);
    };
  }
}), J = () => {
  const t = m(R), e = m(U);
  if (!t || !e)
    throw new Error(
      "AuthProvider context is undefined, please verify you are calling useAuth() as child of a <AuthProvider> component."
    );
  return {
    ...t,
    ...e
  };
}, Q = (t, e, u = sessionStorage) => {
  const c = `oidc.user:${t}:${e}`;
  return () => {
    const o = u.getItem(c);
    return o ? x.fromStorageString(o) : null;
  };
};
export {
  H as AuthProvider,
  R as auth_context_key,
  U as auth_state_key,
  M as stateComputedRefs,
  J as useAuth,
  C as useAuthContextProvider,
  G as useAuthStateProvider,
  T as useAuthStateReducer,
  z as useOidc,
  Q as userGetterGen
};
